org.apache.myfaces.trinidad.validator

## Interface ClientValidator

-     public interface ClientValidator

  Interface implemented by Objects that wish to perform client-side validation in addition to server-side validation. Client side validation should always be the same or or more lenient than the server-side validation.

  One of the benefits of Apache Trinidad is that it supports client-side versions of converters and validators. This means that errors can be caught on the client and a round trip avoided. This interface can be used to add client-side validation to a validator.

  The basic idea of Apache Trinidad's client-side validation is that it works on the client in a very similar way to how it works on the server, except the language on the client is javascript instead of java. Apache Trinidad supports javascript Validator objects that support the method validate(). A Validator can throw a ValidatorException.

  Let's say you've written a javax.faces.validator.Validator implementation and now you want to add client-side validation. The first thing to do is write a version of the validator in javascript. Here is the javascript code for the validator "interface".

       /**
        * Validator "interface" similar to javax.faces.validator.Validator,
        * except that all relevant information must be passed to the constructor
        * as the context and component are not passed to the validate method
        * /
       function Validator(){}

       /**
       * Perform the correctness checks implemented by this Validator.
       * If any violations are found, a ValidatorException will be thrown.
       * /
       Validator.prototype.validate = function(value, label, converter){}

  Validators can throw a ValidatorException, here is the signature:
  - ValidatorException(detail)
    - detail - Localized detail message text
  The method
  - `getClientLibrarySource()` is expected to return a library that has an implementation of the javascript Validator object.
  - `getClientValidation()` is expected to return a javascript constructor which will be used to instantiate an instance of the validator.
  - `getClientScript()` can be used to write out inline js.
  - `getClientImportNames()` is used to import the built-in scripts provided by Apache Trinidad.

  See Also:
    `Validator`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Collection<String>` | `getClientImportNames()` Supports importing the built-in scripts provided by Apache Trinidad.
    `String` | `getClientLibrarySource(javax.faces.context.FacesContext context)` Gets the URI specifying the location of the js lib resource.
    `String` | `getClientScript(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)` Opportunity for the ClientValidator to return script content.
    `String` | `getClientValidation(javax.faces.context.FacesContext context, javax.faces.component.UIComponent component)` Called to retrieve the appropriate client validation code for the node and context.

- - ### Method Detail

    - #### getClientLibrarySource

          String getClientLibrarySource(javax.faces.context.FacesContext context)

      Gets the URI specifying the location of the js lib resource. Only the first reference to a library will result in its being imported.

    - #### getClientImportNames

          Collection<String> getClientImportNames()

      Supports importing the built-in scripts provided by Apache Trinidad. It can be used to ensure that a Javascript function is available before using it in a Javascript handler. Only the first reference to a script will result in its being imported.

      If this function returns null "Validator()" will be used.

      Returns:
        a collection of function names

    - #### getClientScript

          String getClientScript(javax.faces.context.FacesContext context,
                               javax.faces.component.UIComponent component)

      Opportunity for the ClientValidator to return script content. For HTML, this will be javascript that will be embedded in a script tag. For HTML this method is expected to return an implementation of the javascript Validator object.

      Do not rely on this content being ppr updated.

      This method will be called once per validator instance. Content that should only be written once per request should only be returned once.

    - #### getClientValidation

          String getClientValidation(javax.faces.context.FacesContext context,
                                   javax.faces.component.UIComponent component)

      Called to retrieve the appropriate client validation code for the node and context. For HTML, this will be javascript that will be embedded in a script tag. For HTML this method is expected to return a constructor of the javascript Validator object returned by getClientScript().

Copyright © 2001-2017 The Apache Software Foundation. All Rights Reserved.